# TCP Socket client program
# Ed May Nov 15 2011

import socket
import sys
import string
import time

SDELAY = 1.5	# setling time delay (seconds)
HOST = 'daring.cwi.nl'    # The remote host
HOST = 'pcl12.hep.anl.gov'    # The remote host
HOST = 'diva'    # The remote host
HOST = '169.254.169.112'    # The remote host i.e. the power supply
#HOST = '169.254.224.205'    # The remote host i.e. the power supply
PORT = 8003                 # The port as used by the server in power supply
				
#HOST = 'pcl12.hep.anl.gov'    # The remote host when testing
#PORT = 50007			# remote port for testing

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((HOST, PORT))

# dataCollectionModes:	0	single read
#			1	sweep of voltage
#			2	sweep of current
#			3	fix current sweep time
dataCollectionMode = 1
dataCollectionIndex = 0
# establish software limits on voltage and current
voltageSoftLimit = 40.000	# volts
currentSoftLimit =  4.000	# amps
voltageHardLimit = 25.00
currentHardLimit =  1.00
# open an output file in append mode with no buffering
fo1 = open("readLPS.dat","a",0)
fo2 = open("readLPS.meta","a",0)


print "Issue Identity query to ",HOST
s.send('*IDN?')
data = s.recv(1024)
#print 'Received', repr(data)
sdata = string.replace(data,'\n','')
print 'ID string recieved: ', repr(sdata)

print "Query ON/OFF state of the power supply."
s.send('output:state?')
data = s.recv(1024)
#print 'Received', repr(data)
psState = string.replace(data,'\n','')

print "Set the voltage and current limits"
sVoltageLimitMessage=":voltage "+str(voltageHardLimit)
print "Sleep for ", SDELAY, " (sec) to provide settling time."
time.sleep(SDELAY)
s.send(sVoltageLimitMessage)
sCurrentLimitMessage=":current "+str(currentHardLimit)
s.send(sCurrentLimitMessage)
print "Sleep for ", SDELAY, " (sec) to provide settling time."
time.sleep(SDELAY)


print "Query the voltage and current limits:",
s.send('source:voltage?')
data=s.recv(1024)
#print 'Received', repr(data)
sVoltageLimit=string.replace(data,'\n','')
s.send('source:current?')
data=s.recv(1024)
#print 'Received', repr(data)
sCurrentLimit=string.replace(data,'\n','')
print sVoltageLimit,"(volts)",sCurrentLimit,"(amps)"


if  psState == 'OFF' :
	print "Found Power Supply Output state is OFF,"
	sans=raw_input('Turn on Power Supply (Y/N): ')
	if sans == 'Y' :
		print "Turning Power Supply Output ON.."
		s.send('output:state ON') # does not return any message data
		s.send('output:state?')	# ask for state to update psState variable
		data = s.recv(1024)
		psState = string.replace(data,'\n','')
	else :
		print "Exit the program..."
		s.close()
		fo1.close()
		fo2.close()
		sys.exit(1)

print "Query operating mode of the power supply."
print "CV = Constant Voltage CC = Constant Current"
s.send('source:mode?')
data = s.recv(1024)
#print 'Received', repr(data)
sdata = string.replace(data,'\n','')
print "Power Supply operating mode is", sdata

print ""

if psState == 'ON' :
	iNew=0.000
	while iNew > currentSoftLimit :
		print "User requested current > software limit ",currentSoftLimit
		sCurrent=raw_input("Enter new current:")
		iNew=float(sCurrent)
	print "Set current to ",iNew," Amps"
	message = ':current '+str(iNew)
	s.send(message)
	# note this command does not return any data
	print "Sleep for ", SDELAY, " (sec) to provide settling time."
	time.sleep(SDELAY)
	print "Measure Voltage and Current values:"
	s.send('measure:voltage?')
	data=s.recv(1024)
	sdata = string.replace(data,'\n','')
	print 'Output Voltage = ',sdata," (Volts)"
	s.send('measure:current?')
	data=s.recv(1024)
	sdata = string.replace(data,'\n','')
	print 'Output Current = ',sdata," (Amps)"
	s.send('source:mode?')
	data = s.recv(1024)
	sdata = string.replace(data,'\n','')
	print "Power Supply operating mode is", sdata
else :
	print "Power Supplay Output is OFF."

if psState == 'ON' :
	# Do a curve by sweeping the time for fixed current
	dataCollectionMode=1	# voltage sweep
	dataCollectionMode=2	# fix voltage/current sweep time
	dataCollectionIndex=0
	vTimeMin=0.0
	vTimeMax=240.0
	vTimeSteps=120
	sCurrent=raw_input("Enter new current:")
	iMax=float(sCurrent)
	while iMax > currentSoftLimit :
		print "User requested current for a sweep > software limit ",currentSoftLimit
		sCurrent=raw_input("Enter new current:")
		iMax=float(sCurrent)
	fo2.write("offset=%f\n" % time.time())
	fo2.write("unset label\n")		# fix over write of label in gnuplot
	slabel='set label "'+time.ctime()+'" at graph 0.05,0.6 left'
	fo2.write("%s\n" % slabel)
	#print "Set current to ",iNew," Amps"
	message = ':current '+str(iMax)
	s.send(message)
	# note this command does not return any data
	time.sleep(SDELAY)	# initial settling time
	deltaTime = (vTimeMax - vTimeMin) / vTimeSteps
	vNextTime = vTimeMin
	print "Sleep for ", SDELAY, " (sec) to provide settling time."
	print "Scan:","sPSmode,voltRead,currentRead,loadResistance,loadPower"
	while vNextTime < vTimeMax :
		#print "Measure Voltage and Current values:"
		s.send('measure:voltage?')
		data=s.recv(1024)
		sdata = string.replace(data,'\n','')
		voltRead = float(sdata)
		s.send('measure:current?')
		data=s.recv(1024)
		sdata = string.replace(data,'\n','')
		currentRead = float(sdata)
		s.send('source:mode?')
		data = s.recv(1024)
		sPSmode = string.replace(data,'\n','')
		try :
			loadResistance = voltRead/currentRead
		except ZeroDivisionError:
			sLoadResistance = '-'
		else :
			sLoadResistance = str(loadResistance)
		loadPower = voltRead*currentRead
		print "Data:",dataCollectionMode,dataCollectionIndex,sPSmode \
		,voltRead,currentRead,sLoadResistance,loadPower
		timeFromEpoch = time.time()
		timeAndDate = time.ctime()
		fo1.write("%d %d %s %f %f %s %f %f %s\n" % (dataCollectionMode,dataCollectionIndex,sPSmode,
		voltRead,currentRead,sLoadResistance,loadPower,timeFromEpoch,timeAndDate) )
		vNextTime = vNextTime + deltaTime
		time.sleep(deltaTime)
		dataCollectionIndex = dataCollectionIndex +1
else :
	print "Power Supplay Output is OFF."
fo1.close()
fo2.close()

iNew=0.0
print "Set current to ",iNew," Amps at Program Exit."
message = ':current '+str(iNew)
s.send(message)
s.close()
sys.exit(0)
